/* ***********************************************************
 * This file was automatically generated on 2020-03-02.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.HSBType;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletColorV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletColorV2Wrapper extends BrickletColorV2 implements CoMCUFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletColorV2.DEVICE_DISPLAY_NAME, "brickletcolorv2", BrickletColorV2.DEVICE_IDENTIFIER, BrickletColorV2Wrapper.class, BrickletColorV2Actions.class, "2.0.0", true);

    public BrickletColorV2Wrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletColorV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletColorV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletColorV2Config cfg = (BrickletColorV2Config) config.as(BrickletColorV2Config.class);
        this.addColorListener(this.reg((r, g, b, c) -> {if(true) {updateStateFn.accept("BrickletColorV2Color", transformBrickletColorV2ColorCallback0(r, g, b, c, cfg));}}, this::removeColorListener));
		this.addIlluminanceListener(this.reg((illuminance) -> {if(true) {updateStateFn.accept("BrickletColorV2Illuminance", transformBrickletColorV2IlluminanceCallback0(illuminance, cfg));}}, this::removeIlluminanceListener));
		this.addColorTemperatureListener(this.reg((colorTemperature) -> {if(true) {updateStateFn.accept("BrickletColorV2ColorTemperature", transformBrickletColorV2ColorTemperatureCallback0(colorTemperature, cfg));}}, this::removeColorTemperatureListener));
        this.setConfiguration(cfg.gain, cfg.integrationTime);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletColorV2ColorConfig channelCfg = getChannelConfigFn.apply("BrickletColorV2Color").as(BrickletColorV2ColorConfig.class);
		this.setColorCallbackConfiguration(channelCfg.updateInterval, true);
		}
		{
		BrickletColorV2IlluminanceConfig channelCfg = getChannelConfigFn.apply("BrickletColorV2Illuminance").as(BrickletColorV2IlluminanceConfig.class);
		this.setIlluminanceCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletColorV2ColorTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletColorV2ColorTemperature").as(BrickletColorV2ColorTemperatureConfig.class);
		this.setColorTemperatureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletColorV2Config cfg = (BrickletColorV2Config) config.as(BrickletColorV2Config.class);
        this.setColorCallbackConfiguration(0, false);
		this.setIlluminanceCallbackConfiguration(0, true, 'x', 0, 0);
		this.setColorTemperatureCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletColorV2Config cfg = (BrickletColorV2Config) config.as(BrickletColorV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletColorV2Color");
		result.add("BrickletColorV2Illuminance");
		result.add("BrickletColorV2ColorTemperature");
		result.add("BrickletColorV2Light");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletColorV2Color":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletColorV2Color"), "Color", "Color").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletColorV2Color")).withDescription("Measured color")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletColorV2Illuminance":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletColorV2Illuminance"), "Illuminance", "Number:Illuminance").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletColorV2Illuminance")).withDescription("Measured illuminance. To get a correct illuminance measurement make sure that the color values themself are not saturated. The color value (R, G or B) is saturated if it is equal to the maximum value of 255. In that case you have to reduce the gain.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletColorV2ColorTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletColorV2ColorTemperature"), "Color Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletColorV2ColorTemperature")).withDescription("To get a correct color temperature measurement make sure that the color values themself are not saturated. The color value (R, G or B) is saturated if it is equal to the maximum value of 255. In that case you have to reduce the gain.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletColorV2Light":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletColorV2Light"), "Enable Light", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletColorV2Light")).withDescription("Turns the white LED on the Bricklet on/off.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Color Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures color (RGB value), illuminance and color temperature").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletColorV2Color", new ChannelTypeUID("tinkerforge", "BrickletColorV2Color")).withLabel("Color").build(), new ChannelDefinitionBuilder("BrickletColorV2Illuminance", new ChannelTypeUID("tinkerforge", "BrickletColorV2Illuminance")).withLabel("Illuminance").build(), new ChannelDefinitionBuilder("BrickletColorV2ColorTemperature", new ChannelTypeUID("tinkerforge", "BrickletColorV2ColorTemperature")).withLabel("Color Temperature").build(), new ChannelDefinitionBuilder("BrickletColorV2Light", new ChannelTypeUID("tinkerforge", "BrickletColorV2Light")).withLabel("Enable Light").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletcolorv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("gain", Type.INTEGER).withDefault("3").withDescription("Increasing the gain enables the sensor to detect a color from a higher distance.").withLabel("Gain").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "1x"), new ParameterOption("1", "4x"), new ParameterOption("2", "16x"), new ParameterOption("3", "60x"))).build(), ConfigDescriptionParameterBuilder.create("integrationTime", Type.INTEGER).withDefault("3").withDescription("The integration time provides a trade-off between conversion time and accuracy. With a longer integration time the values read will be more accurate but it will take longer time to get the conversion results.").withLabel("Integration Time").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "2ms"), new ParameterOption("1", "24ms"), new ParameterOption("2", "101ms"), new ParameterOption("3", "154ms"), new ParameterOption("4", "700ms"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletColorV2Color":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletColorV2Illuminance":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletColorV2ColorTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletColorV2Light":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletColorV2Config cfg = (BrickletColorV2Config) config.as(BrickletColorV2Config.class);
        switch(channel) {
            case "BrickletColorV2Color": {
                   BrickletColorV2ColorConfig channelCfg = channelConfig.as(BrickletColorV2ColorConfig.class);
                   {
            BrickletColorV2.Color value = this.getColor();
            if(true)
                updateStateFn.accept(channel, transformBrickletColorV2ColorGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletColorV2Illuminance": {
                   BrickletColorV2IlluminanceConfig channelCfg = channelConfig.as(BrickletColorV2IlluminanceConfig.class);
                   {
            long value = this.getIlluminance();
            if(true)
                updateStateFn.accept(channel, transformBrickletColorV2IlluminanceGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletColorV2ColorTemperature": {
                   BrickletColorV2ColorTemperatureConfig channelCfg = channelConfig.as(BrickletColorV2ColorTemperatureConfig.class);
                   {
            int value = this.getColorTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletColorV2ColorTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletColorV2Light": {
                   BrickletColorV2LightConfig channelCfg = channelConfig.as(BrickletColorV2LightConfig.class);
                   {
            boolean value = this.getLight();
            if(true)
                updateStateFn.accept(channel, transformBrickletColorV2LightGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletColorV2Config cfg = (BrickletColorV2Config) config.as(BrickletColorV2Config.class);
        switch(channel) {
            case "BrickletColorV2Light":
                if (command instanceof OnOffType) {
                    BrickletColorV2LightConfig channelCfg = channelConfig.as(BrickletColorV2LightConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setLight(cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletColorV2ColorCallback0(int r, int g, int b, int c, BrickletColorV2Config cfg) {
        return HSBType.fromRGB(r * 255 / 65535, g * 255 / 65535, b * 255 / 65535);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorV2IlluminanceCallback0(long illuminance, BrickletColorV2Config cfg) {
        return new QuantityType<>(illuminance / cfg.gain * cfg.integrationTime / 700.0, SmartHomeUnits.LUX);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorV2ColorTemperatureCallback0(int colorTemperature, BrickletColorV2Config cfg) {
        return new QuantityType<>(colorTemperature, SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorV2ColorGetter0(BrickletColorV2.Color value, BrickletColorV2Config cfg) {
        return HSBType.fromRGB(value.r * 255 / 65535, value.g * 255 / 65535, value.b * 255 / 65535);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorV2IlluminanceGetter0(long value, BrickletColorV2Config cfg) {
        return new QuantityType<>(value / cfg.gain * cfg.integrationTime / 700.0, SmartHomeUnits.LUX);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorV2ColorTemperatureGetter0(int value, BrickletColorV2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorV2LightGetter0(boolean value, BrickletColorV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }

}