/* ***********************************************************
 * This file was automatically generated on 2020-03-02.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletHallEffectV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletHallEffectV2Wrapper extends BrickletHallEffectV2 implements CoMCUFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletHallEffectV2.DEVICE_DISPLAY_NAME, "bricklethalleffectv2", BrickletHallEffectV2.DEVICE_IDENTIFIER, BrickletHallEffectV2Wrapper.class, BrickletHallEffectV2Actions.class, "2.0.0", true);

    public BrickletHallEffectV2Wrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletHallEffectV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletHallEffectV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletHallEffectV2Config cfg = (BrickletHallEffectV2Config) config.as(BrickletHallEffectV2Config.class);
        this.addCounterListener(this.reg((count) -> {if(true) {updateStateFn.accept("BrickletHallEffectV2Counter", transformBrickletHallEffectV2CounterCallback0(count, cfg));}}, this::removeCounterListener));
		this.addMagneticFluxDensityListener(this.reg((magneticFluxDensity) -> {if(true) {updateStateFn.accept("BrickletHallEffectV2MagneticFluxDensity", transformBrickletHallEffectV2MagneticFluxDensityCallback0(magneticFluxDensity, cfg));}}, this::removeMagneticFluxDensityListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletHallEffectV2CounterConfig channelCfg = getChannelConfigFn.apply("BrickletHallEffectV2Counter").as(BrickletHallEffectV2CounterConfig.class);
		this.setCounterConfig(cfg.highThreshold, cfg.lowThreshold, cfg.debounce.longValue());
		            this.setCounterCallbackConfiguration(channelCfg.updateInterval, true);
		}
		{
		BrickletHallEffectV2MagneticFluxDensityConfig channelCfg = getChannelConfigFn.apply("BrickletHallEffectV2MagneticFluxDensity").as(BrickletHallEffectV2MagneticFluxDensityConfig.class);
		this.setMagneticFluxDensityCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletHallEffectV2Config cfg = (BrickletHallEffectV2Config) config.as(BrickletHallEffectV2Config.class);
        this.setCounterCallbackConfiguration(0, true);
		this.setMagneticFluxDensityCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletHallEffectV2Config cfg = (BrickletHallEffectV2Config) config.as(BrickletHallEffectV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletHallEffectV2Counter");
		result.add("BrickletHallEffectV2MagneticFluxDensity");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletHallEffectV2Counter":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletHallEffectV2Counter"), "Counter", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletHallEffectV2Counter")).withDescription("The current value of the counter.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletHallEffectV2MagneticFluxDensity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletHallEffectV2MagneticFluxDensity"), "Magnetic Flux Density", "Number:MagneticFluxDensity").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletHallEffectV2MagneticFluxDensity")).withDescription("Measured magnetic flux density.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.6f").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Hall Effect Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures magnetic flux density between -7mT and +7mT").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletHallEffectV2Counter", new ChannelTypeUID("tinkerforge", "BrickletHallEffectV2Counter")).withLabel("Counter").build(), new ChannelDefinitionBuilder("BrickletHallEffectV2MagneticFluxDensity", new ChannelTypeUID("tinkerforge", "BrickletHallEffectV2MagneticFluxDensity")).withLabel("Magnetic Flux Density").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:bricklethalleffectv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("lowThreshold", Type.INTEGER).withDefault("-2000").withDescription("The low threshold in µT. If the measured magnetic flux density goes below the low threshold, the count of the counter is increased by 1.").withLabel("Low Threshold").build(), ConfigDescriptionParameterBuilder.create("highThreshold", Type.INTEGER).withDefault("2000").withDescription("The high threshold in µT. If the measured magnetic flux density goes above the high threshold, the count of the counter is increased by 1.").withLabel("High Threshold").build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100000").withDescription("The debounce time in µs is the minimum time between two count increments.").withLabel("Debounce Time").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletHallEffectV2Counter":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the counter after OpenHAB reads its value. Use this if you want relative counts per update.").withLabel("Reset Counter On Update").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletHallEffectV2MagneticFluxDensity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletHallEffectV2Config cfg = (BrickletHallEffectV2Config) config.as(BrickletHallEffectV2Config.class);
        switch(channel) {
            case "BrickletHallEffectV2Counter": {
                   BrickletHallEffectV2CounterConfig channelCfg = channelConfig.as(BrickletHallEffectV2CounterConfig.class);
                   {
            long value = this.getCounter(channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletHallEffectV2CounterGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletHallEffectV2MagneticFluxDensity": {
                   BrickletHallEffectV2MagneticFluxDensityConfig channelCfg = channelConfig.as(BrickletHallEffectV2MagneticFluxDensityConfig.class);
                   {
            int value = this.getMagneticFluxDensity();
            if(true)
                updateStateFn.accept(channel, transformBrickletHallEffectV2MagneticFluxDensityGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletHallEffectV2Config cfg = (BrickletHallEffectV2Config) config.as(BrickletHallEffectV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletHallEffectV2CounterCallback0(long count, BrickletHallEffectV2Config cfg) {
        return new QuantityType<>(count, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletHallEffectV2MagneticFluxDensityCallback0(int magneticFluxDensity, BrickletHallEffectV2Config cfg) {
        return new QuantityType<>(magneticFluxDensity / 1000000.0, SmartHomeUnits.TESLA);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletHallEffectV2CounterGetter0(long value, BrickletHallEffectV2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletHallEffectV2MagneticFluxDensityGetter0(int value, BrickletHallEffectV2Config cfg) {
        return new QuantityType<>(value / 1000000.0, SmartHomeUnits.TESLA);
    }

}