/* ***********************************************************
 * This file was automatically generated on 2020-03-02.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.function.Consumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingStatus;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletIndustrialQuadRelay;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIndustrialQuadRelayWrapper extends BrickletIndustrialQuadRelay implements StandardFlashable, DeviceWrapper {
    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIndustrialQuadRelay.DEVICE_DISPLAY_NAME, "brickletindustrialquadrelay", BrickletIndustrialQuadRelay.DEVICE_IDENTIFIER, BrickletIndustrialQuadRelayWrapper.class, BrickletIndustrialQuadRelayActions.class, "2.0.0", false);

    public BrickletIndustrialQuadRelayWrapper(String uid, IPConnection ipcon) {
        super(uid, ipcon);
    }

    private List<ScheduledFuture<?>> manualChannelUpdates = new ArrayList<ScheduledFuture<?>>();
    private List<ListenerReg> listenerRegs = new ArrayList<ListenerReg>();

    public void cancelManualUpdates() {
        manualChannelUpdates.forEach(f -> f.cancel(true));
    }

    public <T> T reg(T listener, Consumer<T> toRemove) {
        listenerRegs.add(new ListenerReg<T>(listener, toRemove));
        return listener;
    }

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelayWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelayWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        this.setResponseExpectedAll(true);
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        this.addMonoflopDoneListener(this.reg((selectionMask, valueMask) -> {if((selectionMask & (1 << 0)) == 1) {updateStateFn.accept("BrickletIndustrialQuadRelayRelay0", transformBrickletIndustrialQuadRelayRelay0Callback0(selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));
		this.addMonoflopDoneListener(this.reg((selectionMask, valueMask) -> {if((selectionMask & (1 << 1)) == 1) {updateStateFn.accept("BrickletIndustrialQuadRelayRelay1", transformBrickletIndustrialQuadRelayRelay1Callback0(selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));
		this.addMonoflopDoneListener(this.reg((selectionMask, valueMask) -> {if((selectionMask & (1 << 2)) == 1) {updateStateFn.accept("BrickletIndustrialQuadRelayRelay2", transformBrickletIndustrialQuadRelayRelay2Callback0(selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));
		this.addMonoflopDoneListener(this.reg((selectionMask, valueMask) -> {if((selectionMask & (1 << 3)) == 1) {updateStateFn.accept("BrickletIndustrialQuadRelayRelay3", transformBrickletIndustrialQuadRelayRelay3Callback0(selectionMask, valueMask, cfg));}}, this::removeMonoflopDoneListener));
        
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        listenerRegs.forEach(reg -> reg.toRemove.accept(reg.listener));

        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialQuadRelayRelay0");
		result.add("BrickletIndustrialQuadRelayRelay1");
		result.add("BrickletIndustrialQuadRelayRelay2");
		result.add("BrickletIndustrialQuadRelayRelay3");
		result.add("BrickletIndustrialQuadRelayMonoflopRelay0");
		result.add("BrickletIndustrialQuadRelayMonoflopRelay1");
		result.add("BrickletIndustrialQuadRelayMonoflopRelay2");
		result.add("BrickletIndustrialQuadRelayMonoflopRelay3");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialQuadRelayRelay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay"), "NOT USED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialQuadRelayRelay")).withDescription("NOT USED").build();
            case "BrickletIndustrialQuadRelayMonoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialQuadRelayMonoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Quad Relay Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4 galvanically isolated solid state relays").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayRelay0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay")).withLabel("Relay 0").withDescription("Switches Relay 0. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayRelay1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay")).withLabel("Relay 1").withDescription("Switches Relay 1. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayRelay2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay")).withLabel("Relay 2").withDescription("Switches Relay 2. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayRelay3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay")).withLabel("Relay 3").withDescription("Switches Relay 3. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayMonoflopRelay0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayMonoflopRelay1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 1").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayMonoflopRelay2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 2").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayMonoflopRelay3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 3").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialquadrelay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIndustrialQuadRelayRelay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialQuadRelayMonoflop":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the relay should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").withAdvanced(true).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        switch(channel) {
            case "BrickletIndustrialQuadRelayRelay0": {
                   BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                   {
            int value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayRelay0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayRelay1": {
                   BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                   {
            int value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayRelay1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayRelay2": {
                   BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                   {
            int value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayRelay2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayRelay3": {
                   BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                   {
            int value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayRelay3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayMonoflopRelay0": {
                   BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                   {
            BrickletIndustrialQuadRelay.Monoflop value = this.getMonoflop((short) 0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayMonoflopRelay0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayMonoflopRelay1": {
                   BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                   {
            BrickletIndustrialQuadRelay.Monoflop value = this.getMonoflop((short) 1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayMonoflopRelay1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayMonoflopRelay2": {
                   BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                   {
            BrickletIndustrialQuadRelay.Monoflop value = this.getMonoflop((short) 2);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayMonoflopRelay2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayMonoflopRelay3": {
                   BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                   {
            BrickletIndustrialQuadRelay.Monoflop value = this.getMonoflop((short) 3);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayMonoflopRelay3Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        switch(channel) {
            case "BrickletIndustrialQuadRelayRelay0":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 0)) : (getValue() & ~(1 << 0)));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayRelay1":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 1)) : (getValue() & ~(1 << 1)));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayRelay2":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 2)) : (getValue() & ~(1 << 2)));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayRelay3":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 3)) : (getValue() & ~(1 << 3)));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayMonoflopRelay0":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 0, channelCfg.monoflopValue.booleanValue() ? (1 << 0) : 0, channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayRelay0", 0));
                break;
            case "BrickletIndustrialQuadRelayMonoflopRelay1":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 1, channelCfg.monoflopValue.booleanValue() ? (1 << 1) : 0, channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayRelay1", 0));
                break;
            case "BrickletIndustrialQuadRelayMonoflopRelay2":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 2, channelCfg.monoflopValue.booleanValue() ? (1 << 2) : 0, channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayRelay2", 0));
                break;
            case "BrickletIndustrialQuadRelayMonoflopRelay3":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 3, channelCfg.monoflopValue.booleanValue() ? (1 << 3) : 0, channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayRelay3", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay0Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 0)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay1Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 1)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay2Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 2)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay3Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 3)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay0Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 0)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay1Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 1)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay2Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 2)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay3Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 3)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayMonoflopRelay0Getter0(BrickletIndustrialQuadRelay.Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayMonoflopRelay1Getter0(BrickletIndustrialQuadRelay.Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayMonoflopRelay2Getter0(BrickletIndustrialQuadRelay.Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayMonoflopRelay3Getter0(BrickletIndustrialQuadRelay.Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }

}